#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=700";
$confSensors = "/usr/bin/sensors";
$confGanglia = "/etc/gmond.conf";
$confSleep   = 5*60; # in seconds

die "Ganglia is not installed"  if ! -r $confGanglia;
die "Sensors are not installed" if ! (-e "/proc/bus/i2c" || -e "/sys/bus/i2c/drivers/i2c_adapter");

my $daemon = grep(/--daemon/,@ARGV);

#die $daemon;

if ($daemon)
  {
    open STDIN,"/dev/null";
    open STDOUT,"/dev/null";
    open STDERR,"/dev/null";
    defined(my $pid = fork)   or die "Can't fork: $!";
    exit if $pid;
    use POSIX qw(setsid);
    setsid();
  }

$ENV{"LANG"} = "C";

$| = 1;

while (1)
  {
    my $gmetricDest = "";

    if (1)
      {
        my $ip;
        my $port;
        
        open(IN,"$confGanglia") || die "Cannot read $confGanglia";
        while (<IN>)
          {
            next if /^#/;
            $ip   = $1 if /mcast_channel +(.*)/;
            $port = $1 if /mcast_port +(.*)/;
          }
        close IN;
        
        $gmetricDest .= " -c$ip " if defined $ip;
        $gmetricDest .= " -p$port " if defined $port;
      }

    if (1)
      {
        my %count;
        my $sensorData = `$confSensors`;

        #$sensorData =~ s/\xb0/x/sg;
        #$sensorData =~ s/.C/ x/sg;
        #$sensorData =~ s/\x43/x/sg;
        
        #print $sensorData;
        
        foreach my $entry (split(/\n/,$sensorData))
          {
            #print "-> $entry\n";
            
            my ($name,$tail) = split(/:\s+/,$entry);
            next unless defined $name;
            next unless defined $tail;
            my ($value,$unit,$tail1) = split(/\s+/,$tail);
            next unless defined $value;
            #print "[$name][$value][$unit][$tail1]\n";
            
            next unless $value =~ /^[\+\-\d]/;
            
            if ($name =~ /\(MB\)/)
              {
                $name =~ s/\(MB\)//;
                $unit = "MB";
              }
            
            $name =~ s/\+/plus /;
            $name =~ s/\-/minus /;
            $name =~ s/\//\_/;
            
            $name =~ s/^\s+//;
            $name =~ s/\s+$//;
            
            if (defined $count{$name})
              {
                $count{$name} ++;
                
                $name .= " ".$count{$name};
              }
            else
              {
                $count{$name} = 1;
              }
            
            #print "[$entry] [$name] [$value] [$unit]\n";
            
            my $cmd = "$confGmetric $gmetricDest -tfloat -n\'sensor $name\' -u$unit -v$value";
            #print "$cmd\n";
            system $cmd;
          }
      }

    last unless $daemon;
    sleep $confSleep;
  }

exit 0;
#end file
